Index: dev/drm2/i915/i915_debug.c
===================================================================
diff --git a/head/sys/dev/drm2/i915/i915_debug.c b/head/sys/dev/drm2/i915/i915_debug.c
--- a/head/sys/dev/drm2/i915/i915_debug.c	(revision 276659)
+++ b/head/sys/dev/drm2/i915/i915_debug.c	(working copy)
@@ -43,7 +43,6 @@
 	FLUSHING_LIST,
 	INACTIVE_LIST,
 	PINNED_LIST,
-	DEFERRED_FREE_LIST,
 };
 
 static const char *
@@ -135,6 +134,8 @@
 		   obj->madv == I915_MADV_DONTNEED ? " purgeable" : "");
 	if (obj->base.name)
 		sbuf_printf(m, " (name: %d)", obj->base.name);
+	if (obj->pin_display)
+		sbuf_printf(m, " (display)");
 	if (obj->fence_reg != I915_FENCE_REG_NONE)
 		sbuf_printf(m, " (fence: %d)", obj->fence_reg);
 	if (obj->gtt_space != NULL)
@@ -175,18 +176,10 @@
 		sbuf_printf(m, "Inactive:\n");
 		head = &dev_priv->mm.inactive_list;
 		break;
-	case PINNED_LIST:
-		sbuf_printf(m, "Pinned:\n");
-		head = &dev_priv->mm.pinned_list;
-		break;
 	case FLUSHING_LIST:
 		sbuf_printf(m, "Flushing:\n");
 		head = &dev_priv->mm.flushing_list;
 		break;
-	case DEFERRED_FREE_LIST:
-		sbuf_printf(m, "Deferred free:\n");
-		head = &dev_priv->mm.deferred_free_list;
-		break;
 	default:
 		DRM_UNLOCK(dev);
 		return (EINVAL);
@@ -245,21 +238,11 @@
 		   count, mappable_count, size, mappable_size);
 
 	size = count = mappable_size = mappable_count = 0;
-	count_objects(&dev_priv->mm.pinned_list, mm_list);
-	sbuf_printf(m, "  %u [%u] pinned objects, %zu [%zu] bytes\n",
-		   count, mappable_count, size, mappable_size);
-
-	size = count = mappable_size = mappable_count = 0;
 	count_objects(&dev_priv->mm.inactive_list, mm_list);
 	sbuf_printf(m, "  %u [%u] inactive objects, %zu [%zu] bytes\n",
 		   count, mappable_count, size, mappable_size);
 
 	size = count = mappable_size = mappable_count = 0;
-	count_objects(&dev_priv->mm.deferred_free_list, mm_list);
-	sbuf_printf(m, "  %u [%u] freed objects, %zu [%zu] bytes\n",
-		   count, mappable_count, size, mappable_size);
-
-	size = count = mappable_size = mappable_count = 0;
 	list_for_each_entry(obj, &dev_priv->mm.gtt_list, gtt_list) {
 		if (obj->fault_mappable) {
 			size += obj->gtt_space->size;
@@ -283,9 +266,10 @@
 }
 
 static int
-i915_gem_gtt_info(struct drm_device *dev, struct sbuf *m, void* data)
+i915_gem_gtt_info(struct drm_device *dev, struct sbuf *m, void *data)
 {
 	struct drm_i915_private *dev_priv = dev->dev_private;
+	uintptr_t list = (uintptr_t)data;
 	struct drm_i915_gem_object *obj;
 	size_t total_obj_size, total_gtt_size;
 	int count;
@@ -295,6 +279,9 @@
 
 	total_obj_size = total_gtt_size = count = 0;
 	list_for_each_entry(obj, &dev_priv->mm.gtt_list, gtt_list) {
+		if (list == PINNED_LIST && obj->pin_count == 0)
+			continue;
+
 		sbuf_printf(m, "   ");
 		describe_obj(m, obj);
 		sbuf_printf(m, "\n");
@@ -420,10 +407,6 @@
 	if (ring->get_seqno) {
 		sbuf_printf(m, "Current sequence (%s): %d\n",
 			   ring->name, ring->get_seqno(ring));
-		sbuf_printf(m, "Waiter sequence (%s):  %d\n",
-			   ring->name, ring->waiting_seqno);
-		sbuf_printf(m, "IRQ sequence (%s):     %d\n",
-			   ring->name, ring->irq_seqno);
 	}
 }
 
@@ -451,7 +434,45 @@
 	if (sx_xlock_sig(&dev->dev_struct_lock))
 		return (EINTR);
 
-	if (!HAS_PCH_SPLIT(dev)) {
+	if (IS_VALLEYVIEW(dev)) {
+		sbuf_printf(m, "Display IER:\t%08x\n",
+			   I915_READ(VLV_IER));
+		sbuf_printf(m, "Display IIR:\t%08x\n",
+			   I915_READ(VLV_IIR));
+		sbuf_printf(m, "Display IIR_RW:\t%08x\n",
+			   I915_READ(VLV_IIR_RW));
+		sbuf_printf(m, "Display IMR:\t%08x\n",
+			   I915_READ(VLV_IMR));
+		for_each_pipe(pipe)
+			sbuf_printf(m, "Pipe %c stat:\t%08x\n",
+				   pipe_name(pipe),
+				   I915_READ(PIPESTAT(pipe)));
+
+		sbuf_printf(m, "Master IER:\t%08x\n",
+			   I915_READ(VLV_MASTER_IER));
+
+		sbuf_printf(m, "Render IER:\t%08x\n",
+			   I915_READ(GTIER));
+		sbuf_printf(m, "Render IIR:\t%08x\n",
+			   I915_READ(GTIIR));
+		sbuf_printf(m, "Render IMR:\t%08x\n",
+			   I915_READ(GTIMR));
+
+		sbuf_printf(m, "PM IER:\t\t%08x\n",
+			   I915_READ(GEN6_PMIER));
+		sbuf_printf(m, "PM IIR:\t\t%08x\n",
+			   I915_READ(GEN6_PMIIR));
+		sbuf_printf(m, "PM IMR:\t\t%08x\n",
+			   I915_READ(GEN6_PMIMR));
+
+		sbuf_printf(m, "Port hotplug:\t%08x\n",
+			   I915_READ(PORT_HOTPLUG_EN));
+		sbuf_printf(m, "DPFLIPSTAT:\t%08x\n",
+			   I915_READ(VLV_DPFLIPSTAT));
+		sbuf_printf(m, "DPINVGTT:\t%08x\n",
+			   I915_READ(DPINVGTT));
+
+	} else if (!HAS_PCH_SPLIT(dev)) {
 		sbuf_printf(m, "Interrupt enable:    %08x\n",
 			   I915_READ(IER));
 		sbuf_printf(m, "Interrupt identity:  %08x\n",
@@ -544,61 +565,6 @@
 	return (0);
 }
 
-static int
-i915_ringbuffer_data(struct drm_device *dev, struct sbuf *m, void *data)
-{
-	drm_i915_private_t *dev_priv = dev->dev_private;
-	struct intel_ring_buffer *ring;
-
-	if (sx_xlock_sig(&dev->dev_struct_lock))
-		return (EINTR);
-	ring = &dev_priv->rings[(uintptr_t)data];
-	if (!ring->obj) {
-		sbuf_printf(m, "No ringbuffer setup\n");
-	} else {
-		u8 *virt = ring->virtual_start;
-		uint32_t off;
-
-		for (off = 0; off < ring->size; off += 4) {
-			uint32_t *ptr = (uint32_t *)(virt + off);
-			sbuf_printf(m, "%08x :  %08x\n", off, *ptr);
-		}
-	}
-	DRM_UNLOCK(dev);
-	return (0);
-}
-
-static int
-i915_ringbuffer_info(struct drm_device *dev, struct sbuf *m, void *data)
-{
-	drm_i915_private_t *dev_priv = dev->dev_private;
-	struct intel_ring_buffer *ring;
-
-	ring = &dev_priv->rings[(uintptr_t)data];
-	if (ring->size == 0)
-		return (0);
-
-	if (sx_xlock_sig(&dev->dev_struct_lock))
-		return (EINTR);
-
-	sbuf_printf(m, "Ring %s:\n", ring->name);
-	sbuf_printf(m, "  Head :    %08x\n", I915_READ_HEAD(ring) & HEAD_ADDR);
-	sbuf_printf(m, "  Tail :    %08x\n", I915_READ_TAIL(ring) & TAIL_ADDR);
-	sbuf_printf(m, "  Size :    %08x\n", ring->size);
-	sbuf_printf(m, "  Active :  %08x\n", intel_ring_get_active_head(ring));
-	sbuf_printf(m, "  NOPID :   %08x\n", I915_READ_NOPID(ring));
-	if (IS_GEN6(dev) || IS_GEN7(dev)) {
-		sbuf_printf(m, "  Sync 0 :   %08x\n", I915_READ_SYNC_0(ring));
-		sbuf_printf(m, "  Sync 1 :   %08x\n", I915_READ_SYNC_1(ring));
-	}
-	sbuf_printf(m, "  Control : %08x\n", I915_READ_CTL(ring));
-	sbuf_printf(m, "  Start :   %08x\n", I915_READ_START(ring));
-
-	DRM_UNLOCK(dev);
-
-	return (0);
-}
-
 static const char *
 ring_str(int ring)
 {
@@ -677,6 +643,7 @@
     struct drm_i915_error_state *error, unsigned ring)
 {
 
+	MPASS((ring < I915_NUM_RINGS));	/* shut up confused gcc */
 	sbuf_printf(m, "%s command stream:\n", ring_str(ring));
 	sbuf_printf(m, "  HEAD: 0x%08x\n", error->head[ring]);
 	sbuf_printf(m, "  TAIL: 0x%08x\n", error->tail[ring]);
@@ -691,8 +658,8 @@
 	if (INTEL_INFO(dev)->gen >= 4)
 		sbuf_printf(m, "  INSTPS: 0x%08x\n", error->instps[ring]);
 	sbuf_printf(m, "  INSTPM: 0x%08x\n", error->instpm[ring]);
+	sbuf_printf(m, "  FADDR: 0x%08x\n", error->faddr[ring]);
 	if (INTEL_INFO(dev)->gen >= 6) {
-		sbuf_printf(m, "  FADDR: 0x%08x\n", error->faddr[ring]);
 		sbuf_printf(m, "  FAULT_REG: 0x%08x\n", error->fault_reg[ring]);
 		sbuf_printf(m, "  SYNC_0: 0x%08x\n",
 			   error->semaphore_mboxes[ring][0]);
@@ -700,21 +667,28 @@
 			   error->semaphore_mboxes[ring][1]);
 	}
 	sbuf_printf(m, "  seqno: 0x%08x\n", error->seqno[ring]);
+	sbuf_printf(m, "  waiting: %s\n", yesno(error->waiting[ring]));
 	sbuf_printf(m, "  ring->head: 0x%08x\n", error->cpu_ring_head[ring]);
 	sbuf_printf(m, "  ring->tail: 0x%08x\n", error->cpu_ring_tail[ring]);
 }
 
-static int i915_error_state(struct drm_device *dev, struct sbuf *m,
+static int
+i915_error_state(struct drm_device *dev, struct sbuf *m,
     void *unused)
 {
 	drm_i915_private_t *dev_priv = dev->dev_private;
 	struct drm_i915_error_state *error;
+	struct intel_ring_buffer *ring;
 	int i, j, page, offset, elt;
 
 	mtx_lock(&dev_priv->error_lock);
-	if (!dev_priv->first_error) {
+	error = dev_priv->first_error;
+	if (error != NULL)
+		refcount_acquire(&error->ref);
+	mtx_unlock(&dev_priv->error_lock);
+	if (error == NULL) {
 		sbuf_printf(m, "no error state collected\n");
-		goto out;
+		return (0);
 	}
 
 	error = dev_priv->first_error;
@@ -723,6 +697,7 @@
 	    (intmax_t)error->time.tv_usec);
 	sbuf_printf(m, "PCI ID: 0x%04x\n", dev->pci_device);
 	sbuf_printf(m, "EIR: 0x%08x\n", error->eir);
+	sbuf_printf(m, "IER: 0x%08x\n", error->ier);
 	sbuf_printf(m, "PGTBL_ER: 0x%08x\n", error->pgtbl_er);
 
 	for (i = 0; i < dev_priv->num_fence_regs; i++)
@@ -734,11 +709,8 @@
 		sbuf_printf(m, "DONE_REG: 0x%08x\n", error->done_reg);
 	}
 
-	i915_ring_error_state(m, dev, error, RCS);
-	if (HAS_BLT(dev))
-		i915_ring_error_state(m, dev, error, BCS);
-	if (HAS_BSD(dev))
-		i915_ring_error_state(m, dev, error, VCS);
+	for_each_ring(ring, dev_priv, i)
+		i915_ring_error_state(m, dev, error, i);
 
 	if (error->active_bo)
 		print_error_buffers(m, "Active",
@@ -801,13 +773,29 @@
 	if (error->display)
 		intel_display_print_error_state(m, dev, error->display);
 
-out:
-	mtx_unlock(&dev_priv->error_lock);
+	if (refcount_release(&error->ref))
+		i915_error_state_free(error);
 
 	return (0);
 }
 
 static int
+i915_error_state_w(struct drm_device *dev, const char *str, void *unused)
+{
+	drm_i915_private_t *dev_priv = dev->dev_private;
+	struct drm_i915_error_state *error;
+
+	DRM_DEBUG_DRIVER("Resetting error state\n");
+	mtx_lock(&dev_priv->error_lock);
+	error = dev_priv->first_error;
+	dev_priv->first_error = NULL;
+	mtx_unlock(&dev_priv->error_lock);
+	if (error != NULL && refcount_release(&error->ref))
+		i915_error_state_free(error);
+	return (0);
+}
+
+static int
 i915_rstdby_delays(struct drm_device *dev, struct sbuf *m, void *unused)
 {
 	drm_i915_private_t *dev_priv = dev->dev_private;
@@ -1081,6 +1069,17 @@
 
 	sbuf_printf(m, "Core Power Down: %s\n",
 		   yesno(gt_core_status & GEN6_CORE_CPD_STATE_MASK));
+
+	/* Not exactly sure what this is */
+	sbuf_printf(m, "RC6 \"Locked to RPn\" residency since boot: %u\n",
+		   I915_READ(GEN6_GT_GFX_RC6_LOCKED));
+	sbuf_printf(m, "RC6 residency since boot: %u\n",
+		   I915_READ(GEN6_GT_GFX_RC6));
+	sbuf_printf(m, "RC6+ residency since boot: %u\n",
+		   I915_READ(GEN6_GT_GFX_RC6p));
+	sbuf_printf(m, "RC6++ residency since boot: %u\n",
+		   I915_READ(GEN6_GT_GFX_RC6pp));
+
 	return 0;
 }
 
@@ -1444,6 +1443,52 @@
 	return (0);
 }
 
+static int i915_dpio_info(struct drm_device *dev, struct sbuf *m, void *data)
+{
+	struct drm_i915_private *dev_priv;
+	int ret;
+
+	if (!IS_VALLEYVIEW(dev)) {
+		sbuf_printf(m, "unsupported\n");
+		return 0;
+	}
+
+	dev_priv = dev->dev_private;
+
+	ret = sx_xlock_sig(&dev->mode_config.mutex);
+	if (ret != 0)
+		return (EINTR);
+
+	sbuf_printf(m, "DPIO_CTL: 0x%08x\n", I915_READ(DPIO_CTL));
+
+	sbuf_printf(m, "DPIO_DIV_A: 0x%08x\n",
+		   intel_dpio_read(dev_priv, _DPIO_DIV_A));
+	sbuf_printf(m, "DPIO_DIV_B: 0x%08x\n",
+		   intel_dpio_read(dev_priv, _DPIO_DIV_B));
+
+	sbuf_printf(m, "DPIO_REFSFR_A: 0x%08x\n",
+		   intel_dpio_read(dev_priv, _DPIO_REFSFR_A));
+	sbuf_printf(m, "DPIO_REFSFR_B: 0x%08x\n",
+		   intel_dpio_read(dev_priv, _DPIO_REFSFR_B));
+
+	sbuf_printf(m, "DPIO_CORE_CLK_A: 0x%08x\n",
+		   intel_dpio_read(dev_priv, _DPIO_CORE_CLK_A));
+	sbuf_printf(m, "DPIO_CORE_CLK_B: 0x%08x\n",
+		   intel_dpio_read(dev_priv, _DPIO_CORE_CLK_B));
+
+	sbuf_printf(m, "DPIO_LFP_COEFF_A: 0x%08x\n",
+		   intel_dpio_read(dev_priv, _DPIO_LFP_COEFF_A));
+	sbuf_printf(m, "DPIO_LFP_COEFF_B: 0x%08x\n",
+		   intel_dpio_read(dev_priv, _DPIO_LFP_COEFF_B));
+
+	sbuf_printf(m, "DPIO_FASTCLK_DISABLE: 0x%08x\n",
+		   intel_dpio_read(dev_priv, DPIO_FASTCLK_DISABLE));
+
+	sx_xunlock(&dev->mode_config.mutex);
+
+	return 0;
+}
+
 static int
 i915_debug_set_wedged(SYSCTL_HANDLER_ARGS)
 {
@@ -1520,57 +1565,77 @@
 	return (0);
 }
 
+static int
+i915_stop_rings(SYSCTL_HANDLER_ARGS)
+{
+	struct drm_device *dev;
+	drm_i915_private_t *dev_priv;
+	int error, val;
+
+	dev = arg1;
+	dev_priv = dev->dev_private;
+	if (dev_priv == NULL)
+		return (EBUSY);
+	DRM_LOCK(dev);
+	val = dev_priv->stop_rings;
+	DRM_UNLOCK(dev);
+	error = sysctl_handle_int(oidp, &val, 0, req);
+	if (error || !req->newptr)
+		return (error);
+	DRM_DEBUG("Stopping rings 0x%08x\n", val);
+
+	DRM_LOCK(dev);
+	dev_priv->stop_rings = val;
+	DRM_UNLOCK(dev);
+	return (0);
+}
+
 static struct i915_info_sysctl_list {
 	const char *name;
 	int (*ptr)(struct drm_device *dev, struct sbuf *m, void *data);
+	int (*ptr_w)(struct drm_device *dev, const char *str, void *data);
 	int flags;
 	void *data;
 } i915_info_sysctl_list[] = {
-	{"i915_capabilities", i915_capabilities, 0},
-	{"i915_gem_objects", i915_gem_object_info, 0},
-	{"i915_gem_gtt", i915_gem_gtt_info, 0},
-	{"i915_gem_active", i915_gem_object_list_info, 0, (void *)ACTIVE_LIST},
-	{"i915_gem_flushing", i915_gem_object_list_info, 0,
+	{"i915_capabilities", i915_capabilities, NULL, 0},
+	{"i915_gem_objects", i915_gem_object_info, NULL, 0},
+	{"i915_gem_gtt", i915_gem_gtt_info, NULL, 0},
+	{"i915_gem_pinned", i915_gem_gtt_info, NULL, 0, (void *)PINNED_LIST},
+	{"i915_gem_active", i915_gem_object_list_info, NULL, 0,
+	    (void *)ACTIVE_LIST},
+	{"i915_gem_flushing", i915_gem_object_list_info, NULL, 0,
 	    (void *)FLUSHING_LIST},
-	{"i915_gem_inactive", i915_gem_object_list_info, 0,
+	{"i915_gem_inactive", i915_gem_object_list_info, NULL, 0,
 	    (void *)INACTIVE_LIST},
-	{"i915_gem_pinned", i915_gem_object_list_info, 0,
-	    (void *)PINNED_LIST},
-	{"i915_gem_deferred_free", i915_gem_object_list_info, 0,
-	    (void *)DEFERRED_FREE_LIST},
-	{"i915_gem_pageflip", i915_gem_pageflip_info, 0},
-	{"i915_gem_request", i915_gem_request_info, 0},
-	{"i915_gem_seqno", i915_gem_seqno_info, 0},
-	{"i915_gem_fence_regs", i915_gem_fence_regs_info, 0},
-	{"i915_gem_interrupt", i915_interrupt_info, 0},
-	{"i915_gem_hws", i915_hws_info, 0, (void *)RCS},
-	{"i915_gem_hws_blt", i915_hws_info, 0, (void *)BCS},
-	{"i915_gem_hws_bsd", i915_hws_info, 0, (void *)VCS},
-	{"i915_ringbuffer_data", i915_ringbuffer_data, 0, (void *)RCS},
-	{"i915_ringbuffer_info", i915_ringbuffer_info, 0, (void *)RCS},
-	{"i915_bsd_ringbuffer_data", i915_ringbuffer_data, 0, (void *)VCS},
-	{"i915_bsd_ringbuffer_info", i915_ringbuffer_info, 0, (void *)VCS},
-	{"i915_blt_ringbuffer_data", i915_ringbuffer_data, 0, (void *)BCS},
-	{"i915_blt_ringbuffer_info", i915_ringbuffer_info, 0, (void *)BCS},
-	{"i915_error_state", i915_error_state, 0},
-	{"i915_rstdby_delays", i915_rstdby_delays, 0},
-	{"i915_cur_delayinfo", i915_cur_delayinfo, 0},
-	{"i915_delayfreq_table", i915_delayfreq_table, 0},
-	{"i915_inttoext_table", i915_inttoext_table, 0},
-	{"i915_drpc_info", i915_drpc_info, 0},
-	{"i915_emon_status", i915_emon_status, 0},
-	{"i915_ring_freq_table", i915_ring_freq_table, 0},
-	{"i915_gfxec", i915_gfxec, 0},
-	{"i915_fbc_status", i915_fbc_status, 0},
-	{"i915_sr_status", i915_sr_status, 0},
+	{"i915_gem_pageflip", i915_gem_pageflip_info, NULL, 0},
+	{"i915_gem_request", i915_gem_request_info, NULL, 0},
+	{"i915_gem_seqno", i915_gem_seqno_info, NULL, 0},
+	{"i915_gem_fence_regs", i915_gem_fence_regs_info, NULL, 0},
+	{"i915_gem_interrupt", i915_interrupt_info, NULL, 0},
+	{"i915_gem_hws", i915_hws_info, NULL, 0, (void *)RCS},
+	{"i915_gem_hws_blt", i915_hws_info, NULL, 0, (void *)BCS},
+	{"i915_gem_hws_bsd", i915_hws_info, NULL, 0, (void *)VCS},
+	{"i915_error_state", i915_error_state, i915_error_state_w, 0},
+	{"i915_rstdby_delays", i915_rstdby_delays, NULL, 0},
+	{"i915_cur_delayinfo", i915_cur_delayinfo, NULL, 0},
+	{"i915_delayfreq_table", i915_delayfreq_table, NULL, 0},
+	{"i915_inttoext_table", i915_inttoext_table, NULL, 0},
+	{"i915_drpc_info", i915_drpc_info, NULL, 0},
+	{"i915_emon_status", i915_emon_status, NULL, 0},
+	{"i915_ring_freq_table", i915_ring_freq_table, NULL, 0},
+	{"i915_gfxec", i915_gfxec, NULL, 0},
+	{"i915_fbc_status", i915_fbc_status, NULL, 0},
+	{"i915_sr_status", i915_sr_status, NULL, 0},
 #if 0
-	{"i915_opregion", i915_opregion, 0},
+	{"i915_opregion", i915_opregion, NULL, 0},
 #endif
-	{"i915_gem_framebuffer", i915_gem_framebuffer_info, 0},
-	{"i915_context_status", i915_context_status, 0},
-	{"i915_gen6_forcewake_count_info", i915_gen6_forcewake_count_info, 0},
-	{"i915_swizzle_info", i915_swizzle_info, 0},
-	{"i915_ppgtt_info", i915_ppgtt_info, 0},
+	{"i915_gem_framebuffer", i915_gem_framebuffer_info, NULL, 0},
+	{"i915_context_status", i915_context_status, NULL, 0},
+	{"i915_gen6_forcewake_count_info", i915_gen6_forcewake_count_info,
+	    NULL, 0},
+	{"i915_swizzle_info", i915_swizzle_info, NULL, 0},
+	{"i915_ppgtt_info", i915_ppgtt_info, NULL, 0},
+	{"i915_dpio", i915_dpio_info, NULL, 0},
 };
 
 struct i915_info_sysctl_thunk {
@@ -1586,6 +1651,7 @@
 	struct i915_info_sysctl_thunk *thunk;
 	struct drm_device *dev;
 	drm_i915_private_t *dev_priv;
+	char *p;
 	int error;
 
 	thunk = arg1;
@@ -1602,6 +1668,19 @@
 	if (error == 0)
 		error = sbuf_finish(&m);
 	sbuf_delete(&m);
+	if (error != 0 || req->newptr == NULL)
+		return (error);
+	if (req->newlen > 2048)
+		return (E2BIG);
+	p = malloc(req->newlen + 1, M_TEMP, M_WAITOK);
+	error = SYSCTL_IN(req, p, req->newlen);
+	if (error != 0)
+		goto out;
+	p[req->newlen] = '\0';
+	error = i915_info_sysctl_list[thunk->idx].ptr_w(dev, p,
+	    thunk->arg);
+out:
+	free(p, M_TEMP);
 	return (error);
 }
 
@@ -1632,7 +1711,9 @@
 		return (ENOMEM);
 	for (i = 0; i < DRM_ARRAY_SIZE(i915_info_sysctl_list); i++) {
 		oid = SYSCTL_ADD_OID(ctx, SYSCTL_CHILDREN(info), OID_AUTO,
-		    i915_info_sysctl_list[i].name, CTLTYPE_STRING | CTLFLAG_RD,
+		    i915_info_sysctl_list[i].name, CTLTYPE_STRING |
+		    (i915_info_sysctl_list[i].ptr_w != NULL ? CTLFLAG_RW :
+		    CTLFLAG_RD),
 		    &thunks[i], 0, i915_info_sysctl_handler, "A", NULL);
 		if (oid == NULL)
 			return (ENOMEM);
@@ -1655,6 +1736,11 @@
 	    0, i915_cache_sharing, "I", NULL);
 	if (oid == NULL)
 		return (ENOMEM);
+	oid = SYSCTL_ADD_PROC(ctx, SYSCTL_CHILDREN(top), OID_AUTO,
+	    "stop_rings", CTLTYPE_INT | CTLFLAG_RW | CTLFLAG_MPSAFE, dev,
+	    0, i915_stop_rings, "I", NULL);
+	if (oid == NULL)
+		return (ENOMEM);
 	oid = SYSCTL_ADD_INT(ctx, SYSCTL_CHILDREN(top), OID_AUTO, "sync_exec",
 	    CTLFLAG_RW, &i915_gem_sync_exec_requests, 0, NULL);
 	if (oid == NULL)
